#include <stdio.h>
#include <stdlib.h>

#define MAXKL 1000
#define MAXMN 1000
#define MAXF (MAXKL*MAXKL)

int K, L, M, N;
int KK, LL, MM, NN;
char map[MAXKL+2][MAXKL+2];
int room[MAXKL+2][MAXKL+2];
int queue[MAXF][2];
int inside[MAXF+1];
int nrooms;

#if 1
#define ASSERT(_x) do { if (!(_x)) { fprintf(stderr, "Assertion failure at line %d\n", __LINE__); exit(99); } } while (0)
#else
#define ASSERT(_x) do { } while (0)
#endif

void chew(void)
{
	int cc = scanf("%d%d%d%d", &K, &L, &M, &N);
	ASSERT(cc = 4);
	ASSERT(K >= 1 && K <= MAXKL);
	ASSERT(L >= 1 && L <= MAXKL);
	ASSERT(M >= 1 && M <= MAXMN);
	ASSERT(N >= 1 && N <= MAXMN);

	int c = getchar();
	ASSERT(c == '\n');

	for (int i=1; i<=K; i++) {
		for (int j=1; j<=L; j++) {
			c = getchar();
			ASSERT(c == '.' || c == '#');
			map[i][j] = c;
		}
		c = getchar();
		ASSERT(c == '\n');
	}
	c = getchar();
	ASSERT(c < 0);
}

void bfs(void)
{
	for (int i=1; i<=K; i++)
		for (int j=1; j<=L; j++)
			if (!room[i][j] && map[i][j] == '.') {
#define C(a,b) if (!room[a][b] && map[a][b] == '.') { room[a][b] = nrooms; queue[w][0] = a; queue[w][1] = b; w++; }
				nrooms++;
				int r = 0;
				int w = 0;
				C(i, j);
				while (r < w) {
					int x = queue[r][0];
					int y = queue[r][1];
					r++;
					C(x-1, y);
					C(x+1, y);
					C(x, y-1);
					C(x, y+1);
				}
#undef C
			}
	// printf("nrooms = %d\n", nrooms);
}


int areas;
int amax;

static inline void enter(int i, int j)
{
	ASSERT(i >= 0 && i < KK && j >= 0 && j < LL);
	if (room[i][j] && ++inside[room[i][j]] == 1)
		areas++;
}

static inline void leave(int i, int j)
{
	ASSERT(i >= 0 && i < KK && j >= 0 && j < LL);
	if (room[i][j] && --inside[room[i][j]] == 0)
		areas--;
}

void solve_x(void)
{
	for (int i=0; i <= KK-MM; i++) {
		for (int j = -NN+1; j <= LL; j++) {
			int l = j - 1;
			if (l >= 0) {
				for (int k=i+1; k<i+MM-1; k++)
					leave(k, l);
			}
			if (j >= 0 && j < LL) {
				leave(i, j);
				leave(i+MM-1, j);
			}
			l = j + NN - 1;
			if (l < LL) {
				for (int k=i+1; k<i+MM-1; k++)
					enter(k, l);
			}
			if (l > 0 && l-1 < LL) {
				enter(i, l-1);
				enter(i+MM-1, l-1);
			}
			if (areas > amax)
				amax = areas;
		}
		// for (int i=1; i<=nrooms; i++) ASSERT(!inside[i]);
		ASSERT(!areas);
	}
}

void solve_y(void)
{
	for (int j=0; j <= LL-NN; j++) {
		for (int i = -MM+1; i <= KK; i++) {
			int k = i - 1;
			if (k >= 0) {
				for (int l=j+1; l<j+NN-1; l++)
					leave(k, l);
			}
			if (i >= 0 && i < KK) {
				leave(i, j);
				leave(i, j+NN-1);
			}
			k = i + MM - 1;
			if (k < KK) {
				for (int l=j+1; l<j+NN-1; l++)
					enter(k, l);
			}
			if (k > 0 && k-1 < KK) {
				enter(k-1, j);
				enter(k-1, j+NN-1);
			}
			if (areas > amax)
				amax = areas;
		}
		// for (int i=1; i<=nrooms; i++) ASSERT(!inside[i]);
		ASSERT(!areas);
	}
}

int main(void)
{
	chew();
	KK=K+2; LL=L+2; MM=M+2; NN=N+2;
	bfs();
	(M >= N ? solve_x : solve_y)();
	printf("%d\n", amax);
	return 0;
}
